## qca2 2.3.5

=== CMakeLists.txt ===
# Checking for user explicitly defined CMAKE_INSTALL_PREFIX
# It must be done before project(...)
if(NOT CMAKE_INSTALL_PREFIX)
  set(QCA_INSTALL_IN_QT_PREFIX ON)
  # If CMAKE_INSTALL_PREFIX is set in cmake arguments
  unset(CMAKE_INSTALL_PREFIX CACHE)
endif()

# The cmake min. version should be set before calling project(...) too
cmake_minimum_required(VERSION 3.16)

project(qca)

set(QCA_LIB_MAJOR_VERSION "2")
set(QCA_LIB_MINOR_VERSION "3")
set(QCA_LIB_PATCH_VERSION "5")

if(POLICY CMP0042)
  cmake_policy(SET CMP0042 OLD)
endif()

option(BUILD_WITH_QT6 "Build with Qt 6" OFF)
option(BUILD_TESTS "Create test" ON)
option(BUILD_TOOLS "Compile mozcerts and qcatool" ON)
set(BUILD_PLUGINS "auto" CACHE STRING "Plugins for building (also possible values: none, all and auto)")
# BUILD_SHARED_LIBS is cmake variable. Need to change default value.
option(BUILD_SHARED_LIBS "Build shared library" ON)
option(DEVELOPER_MODE "Special developer mode" OFF)

if(QT6)
	set(BUILD_WITH_QT6 ON)
endif()

if(APPLE)
  option(OSX_FRAMEWORK "Build a Mac OS X Framework" ON)
else()
  set(OSX_FRAMEWORK OFF)
endif()

find_package(Doxygen)

string(TOLOWER "${BUILD_PLUGINS}" BUILD_PLUGINS)
if(NOT BUILD_PLUGINS)
  set(BUILD_PLUGINS "none")
endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" )

# Do not automatically link Qt executables to qtmain target on Windows.
# QCA exucatables use console mode only. Not need to link against qtmain.lib.
if(BUILD_WITH_QT6)
  set(QT_MAJOR_VERSION 6)
  message(STATUS "Building Qt 6 version")
  find_package(Qt6 COMPONENTS Core Test Core5Compat REQUIRED)
else()
  set(QT_MAJOR_VERSION 5)
  message(STATUS "Building Qt 5 version")
  set(Qt5_NO_LINK_QTMAIN ON)
  find_package(Qt5 5.14 REQUIRED Core)
endif()

set(CMAKE_AUTOMOC ON)

include(QcaMacro)
include(GNUInstallDirs)
setup_qt_dirs()
if(BUILD_WITH_QT6)
  set(QCA_QT_PC_VERSION "Qt6Core")
  set(QCA_SUFFIX "qt6")
else()
  set(QCA_QT_PC_VERSION "Qt5Core")
  set(QCA_SUFFIX "qt5")
endif()

# QCA can be shared but plugins will be static
# if Qt is static.
if(NOT BUILD_SHARED_LIBS OR QT_IS_STATIC)
  set(STATIC_PLUGINS ON)
  add_definitions(-DQT_STATICPLUGIN)
  set(PLUGIN_TYPE "STATIC")
else()
  set(PLUGIN_TYPE "MODULE")
endif()

set(QCA_SUFFIX "${QCA_SUFFIX}" CACHE STRING "QCA common suffix")
if(QCA_SUFFIX)
  set(QCA_LIB_NAME qca-${QCA_SUFFIX})
  set(QCA_TOOL_NAME qcatool-${QCA_SUFFIX})
  set(MOZCERTS_NAME mozcerts-${QCA_SUFFIX})
  set(QCA_PC_NAME qca2-${QCA_SUFFIX}.pc)
  set(QCA_CONFIG_NAME_BASE "Qca-${QCA_SUFFIX}")
else()
  set(QCA_LIB_NAME qca)
  set(QCA_TOOL_NAME qcatool)
  set(MOZCERTS_NAME mozcerts)
  set(QCA_PC_NAME qca2.pc)
  set(QCA_CONFIG_NAME_BASE "Qca")
endif()

set(QCA_LIB_VERSION_STRING "${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}")

configure_file("include/QtCrypto/qca_version.h.in" "${CMAKE_BINARY_DIR}/qca_version.h")

if (WIN32)
 set(CMAKE_DEBUG_POSTFIX "d")
 add_definitions(-DWIN32_LEAN_AND_MEAN)
elseif (APPLE)
 set(CMAKE_DEBUG_POSTFIX "_debug")
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   if (CMAKE_SYSTEM_NAME MATCHES Linux)
     add_definitions (-D_DEFAULT_SOURCE)
     # on arm -Wcast-align throws many internal qt warning
     if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
     endif()

     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -Wundef -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wundef -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")

     if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override -Wlogical-op" )
     endif()
   endif()
endif()

add_definitions(-DQT_NO_CAST_TO_ASCII
                -DQT_NO_CAST_FROM_ASCII
                -DQT_NO_URL_CAST_FROM_STRING
                -DQT_NO_CAST_FROM_BYTEARRAY
                -DQT_NO_SIGNALS_SLOTS_KEYWORDS
                -DQT_USE_QSTRINGBUILDER
                -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

if (NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

include_directories("include/QtCrypto/")
# for generated files
include_directories(${CMAKE_BINARY_DIR})

if(NOT DEVELOPER_MODE)
  # uninstall target
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

# Always include srcdir and builddir in include path
# This saves typing ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY} in about every subdir
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# put the include dirs which are in the source or build tree
# before all other include dirs, so the headers in the sources
# are prefered over the already installed ones
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(qca_INCLUDEDIR "${CMAKE_CURRENT_SOURCE_DIR}/include" )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
# Use the same path for shared and static library
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )

if( QCA_INSTALL_IN_QT_PREFIX )
  set(QCA_PREFIX_INSTALL_DIR "${QT_PREFIX_DIR}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${QT_PLUGINS_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${QT_BINARY_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${QT_LIBRARY_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${QT_MKSPECS_DIR}/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${QT_DOC_DIR}/html/qca/" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${QT_DATA_DIR}/man" CACHE PATH "Directory where qca man pages will install")
else()
  # Cmake says nothing about LIB_SUFFIX
  # de facto it is a standard way to specify lib suffix on many distros
  set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
  set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "Directory where lib will install")

  set(QCA_PREFIX_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${LIB_INSTALL_DIR}/${QCA_LIB_NAME}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${LIB_INSTALL_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/mkspecs/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/${QCA_LIB_NAME}/html" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Directory where qca man pages will install")
endif()

set(PKGCONFIG_INSTALL_PREFIX "${QCA_LIBRARY_INSTALL_DIR}/pkgconfig" CACHE PATH "Base directory for pkgconfig files")

normalize_path(QCA_PREFIX_INSTALL_DIR)

if(OSX_FRAMEWORK)
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_LIBRARY_INSTALL_DIR}/${QCA_LIB_NAME}.framework/Headers")
else()
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_INCLUDE_INSTALL_DIR}/QtCrypto")
endif()

# check for oportunity to use relative paths
option(USE_RELATIVE_PATHS "Try to make relocatable package")

foreach(PATH QCA_PLUGINS_INSTALL_DIR
             QCA_BINARY_INSTALL_DIR
             QCA_LIBRARY_INSTALL_DIR
             QCA_FEATURE_INSTALL_DIR
             QCA_INCLUDE_INSTALL_DIR
             QCA_PRIVATE_INCLUDE_INSTALL_DIR
             QCA_DOC_INSTALL_DIR
             QCA_MAN_INSTALL_DIR
             PKGCONFIG_INSTALL_PREFIX)

  # Normalize path before comparsion
  normalize_path(${PATH})

  # if all paths are subdirs of CMAKE_INSTALL_PREFIX it is possible to use relative paths
  string(FIND "${${PATH}}" "${QCA_PREFIX_INSTALL_DIR}/" POS)
  if(NOT "${POS}" STREQUAL "0")
    set(USE_RELATIVE_PATHS OFF)
  endif()
endforeach()

if(NOT WIN32)
  if(OSX_FRAMEWORK)
    set(PKGCONFIG_CFLAGS "-F\${libdir} -I\${includedir}")
    set(PKGCONFIG_LIBS "-F\${libdir} -framework ${QCA_LIB_NAME}")
  else()
    set(PKGCONFIG_CFLAGS "-I\${includedir}")
    set(PKGCONFIG_LIBS "-L\${libdir} -l${QCA_LIB_NAME}")
  endif()

  if(NOT BUILD_WITH_QT6)
    # qca2.pc uses absolute paths. So it must be there. Don't rellocate this.
    configure_file("qca2.pc.cmake" "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" @ONLY)
    if(NOT DEVELOPER_MODE)
      install(FILES "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
    endif()
  endif()
endif()

# strip CMAKE_INSTALL_PREFIX in all paths
if(USE_RELATIVE_PATHS)
  message(STATUS "Installed package is relocatable")
  file(RELATIVE_PATH CRYPTO_PRF_RELATIVE_PATH "${QCA_FEATURE_INSTALL_DIR}" ${CMAKE_INSTALL_PREFIX})
  set(CRYPTO_PRF_RELATIVE_PATH "$$PWD/${CRYPTO_PRF_RELATIVE_PATH}")
  foreach(PATH QCA_PLUGINS_INSTALL_DIR
               QCA_BINARY_INSTALL_DIR
               QCA_LIBRARY_INSTALL_DIR
               QCA_FEATURE_INSTALL_DIR
               QCA_INCLUDE_INSTALL_DIR
               QCA_PRIVATE_INCLUDE_INSTALL_DIR
               QCA_DOC_INSTALL_DIR
               QCA_MAN_INSTALL_DIR
               PKGCONFIG_INSTALL_PREFIX)

     file(RELATIVE_PATH ${PATH} ${CMAKE_INSTALL_PREFIX} "${${PATH}}")
  endforeach()
else()
  message(STATUS "Installed package is NOT relocatable")
  set(CRYPTO_PRF_RELATIVE_PATH "")
endif()

if(DEVELOPER_MODE)
  add_definitions(-DDEVELOPER_MODE)

# To prefer plugins from build tree when run qca from build tree
  file(WRITE ${CMAKE_BINARY_DIR}/bin/qt.conf
"[Paths]
Plugins=${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}
")
endif()

if (APPLE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()

message(STATUS "Checking for certstore..")
# fixme add OR mac
if( WIN32 )
    # USE BUILTIN
else()
  if ( DEFINED ENV{QC_CERTSTORE_PATH} )
    if(EXISTS $ENV{QC_CERTSTORE_PATH})

=== examples/CMakeLists.txt ===
find_package(Qt${QT_MAJOR_VERSION} REQUIRED Network)
if(NOT BUILD_WITH_QT6)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
endif()
add_subdirectory(aes-cmac)
add_subdirectory(base64test)
add_subdirectory(certtest)
add_subdirectory(ciphertest)
add_subdirectory(cms)
# this is not meant to be added, because it introduces
# a dependency on QtGui.
# add_subdirectory(cmssigner)
add_subdirectory(eventhandlerdemo)
add_subdirectory(hashtest)
add_subdirectory(hextest)
add_subdirectory(keyloader)
add_subdirectory(mactest)
add_subdirectory(md5crypt)
add_subdirectory(providertest)
add_subdirectory(publickeyexample)
add_subdirectory(randomtest)
add_subdirectory(rsatest)
add_subdirectory(saslclient)
add_subdirectory(saslserver)
add_subdirectory(ssltest)
add_subdirectory(sslservtest)
add_subdirectory(tlssocket)

=== src/CMakeLists.txt ===
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES(sys/filio.h HAVE_SYS_FILIO_H)
IF(HAVE_SYS_FILIO_H)
  ADD_DEFINITIONS(-DHAVE_SYS_FILIO_H)
ENDIF(HAVE_SYS_FILIO_H)

INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
# include <stdlib.h>
# include <sys/mman.h>
int main() { void *f = 0; return mlock(f,8); }
" MLOCK_TAKES_VOID)
if(NOT MLOCK_TAKES_VOID)
  MESSAGE(STATUS "mlock(2) does not take a void *")
  ADD_DEFINITIONS(-DMLOCK_NOT_VOID_PTR)
endif()

if(DEVELOPER_MODE)
  add_definitions(-DQCA_PLUGIN_PATH="${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}")
else()
  if(USE_RELATIVE_PATHS)
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PREFIX_INSTALL_DIR}/${QCA_PLUGINS_INSTALL_DIR}")
  else()
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PLUGINS_INSTALL_DIR}")
  endif()
endif()

# base source files


SET( SOURCES
	qca_tools.cpp
	qca_plugin.cpp
	qca_textfilter.cpp
	qca_basic.cpp
	support/logger.cpp
	qca_cert.cpp
	qca_core.cpp
	qca_default.cpp
	qca_keystore.cpp
	qca_publickey.cpp
	qca_safeobj.cpp
	qca_safetimer.cpp
	qca_securelayer.cpp
	qca_securemessage.cpp
	support/qpipe.cpp
	support/console.cpp
	support/synchronizer.cpp
	support/dirwatch.cpp
	support/syncthread.cpp
)

IF (WIN32)
  SET( SOURCES ${SOURCES} qca_systemstore_win.cpp )
elseif(APPLE AND NOT IOS)
  set( SOURCES ${SOURCES} qca_systemstore_mac.cpp)
else()
  SET( SOURCES ${SOURCES} qca_systemstore_flatfile.cpp )
endif()

# Support files
#SET( qca_HEADERS ${qca_HEADERS} support/dirwatch/dirwatch_p.h )

# Botan tools
SET( botan_BASE botantools/botan )


INCLUDE_DIRECTORIES(support ${botan_BASE} )

ADD_DEFINITIONS(
	-DBOTAN_TYPES_QT
	-DBOTAN_NO_INIT_H
	-DBOTAN_NO_CONF_H
	-DBOTAN_TOOLS_ONLY
	-DBOTAN_MINIMAL_BIGINT
)

ADD_DEFINITIONS(
  -DBOTAN_MP_WORD_BITS=32
  -DBOTAN_KARAT_MUL_THRESHOLD=12
  -DBOTAN_KARAT_SQR_THRESHOLD=12
  -DBOTAN_EXT_MUTEX_QT
)

if(UNIX)
   ADD_DEFINITIONS( -DBOTAN_EXT_ALLOC_MMAP)
endif()

SET( botan_SOURCES
	${botan_BASE}/util.cpp
	${botan_BASE}/exceptn.cpp
	${botan_BASE}/mutex.cpp
	${botan_BASE}/mux_qt/mux_qt.cpp
	${botan_BASE}/charset.cpp
	${botan_BASE}/defalloc.cpp
	${botan_BASE}/mp_comba.cpp
	${botan_BASE}/mp_mul.cpp
	${botan_BASE}/mp_shift.cpp
	${botan_BASE}/mp_misc.cpp
	${botan_BASE}/divide.cpp
	${botan_BASE}/big_base.cpp
	${botan_BASE}/big_code.cpp
	${botan_BASE}/big_io.cpp
	${botan_BASE}/big_ops2.cpp
	${botan_BASE}/big_ops3.cpp
	${botan_BASE}/bit_ops.cpp
	${botan_BASE}/libstate.cpp
	${botan_BASE}/mem_pool.cpp
	${botan_BASE}/modules.cpp
	${botan_BASE}/mp_asm.cpp
	${botan_BASE}/mp_mulop.cpp
	${botan_BASE}/parsing.cpp
)

IF (UNIX)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_unix/mlock.cpp)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/alloc_mmap/mmap_mem.cpp)
ENDIF (UNIX)

IF(WIN32)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_win32/mlock.cpp)
ENDIF(WIN32)

SET( SOURCES ${SOURCES} ${botan_SOURCES})

add_library(${QCA_LIB_NAME} ${SOURCES}  ${public_HEADERS})
target_link_libraries(${QCA_LIB_NAME} Qt${QT_MAJOR_VERSION}::Core)
if(BUILD_WITH_QT6)
  target_link_libraries(${QCA_LIB_NAME} Qt6::Core5Compat)
endif()

if(WIN32)
	TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} crypt32 ws2_32)
endif()

if(APPLE AND NOT IOS)
  set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
  set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
  TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})

  if(NOT USE_RELATIVE_PATHS)
    set_target_properties(${QCA_LIB_NAME} PROPERTIES
                          INSTALL_NAME_DIR "${QCA_LIBRARY_INSTALL_DIR}"
    )
  endif()
endif()

if(NOT ANDROID)
  set_target_properties(${QCA_LIB_NAME} PROPERTIES
                        VERSION ${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}
                        SOVERSION ${QCA_LIB_MAJOR_VERSION}
                        )
endif()

set_target_properties(${QCA_LIB_NAME} PROPERTIES
                      DEFINE_SYMBOL QCA_MAKEDLL
                      PUBLIC_HEADER "${public_HEADERS}"
                      FRAMEWORK ${OSX_FRAMEWORK}
                      FRAMEWORK_VERSION ${QCA_LIB_MAJOR_VERSION}
                      EXPORT_NAME ${QCA_LIB_NAME}
                      )

if(NOT DEVELOPER_MODE)
  # Do not split 'PUBLIC_HEADER ...' line. It means install headers to folder
  # and set this folder as -I flag for imported target.
  # Also EXPORT doesn't actually install any files. It only created a new target.
  install(TARGETS ${QCA_LIB_NAME} EXPORT ${QCA_CONFIG_NAME_BASE}Targets
          LIBRARY DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_BINARY_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          FRAMEWORK DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          PUBLIC_HEADER DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}" INCLUDES DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}"
  )
  install_pdb(${QCA_LIB_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== tools/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
add_subdirectory(mozcerts)
add_subdirectory(qcatool)

=== plugins/qca-botan/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)
if(WITH_botan_PLUGIN STREQUAL "yes")
  pkg_check_modules(BOTAN REQUIRED IMPORTED_TARGET botan-2)
else()
  pkg_check_modules(BOTAN IMPORTED_TARGET botan-2)
endif()

if(BOTAN_FOUND)
  enable_plugin("botan")

  set(QCA_BOTAN_SOURCES qca-botan.cpp)
  add_library(qca-botan ${PLUGIN_TYPE} ${QCA_BOTAN_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-botan  PROPERTY SUFFIX ".dylib")
  endif()

  target_link_libraries(qca-botan Qt${QT_MAJOR_VERSION}::Core ${QCA_LIB_NAME} PkgConfig::BOTAN)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-botan
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-botan ${QCA_CRYPTO_INSTALL_DIR})
  endif()

else()
  disable_plugin("botan")
endif()

=== plugins/qca-wincrypto/CMakeLists.txt ===
# QCA WinCrypto

IF (WIN32)
   SET (QCA_WINCRYPTO_SOURCES qca-wincrypto.cpp)

   ADD_LIBRARY (qca-wincrypto MODULE ${QCA_WINCRYPTO_SOURCES})
   # use win32 includes
   target_link_libraries(qca-wincrypto Qt${QT_MAJOR_VERSION}::Core)
   TARGET_LINK_LIBRARIES (qca-wincrypto ${QCA_LIB_NAME})
   TARGET_LINK_LIBRARIES (qca-wincrypto advapi32)

   INSTALL (TARGETS qca-wincrypto
        LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
        ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
        RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
   )
ENDIF (WIN32)

=== unittest/keystore/CMakeLists.txt ===
ENABLE_TESTING()

set(keystoreunittest_bin_SRCS keystore.cpp)  

add_executable( keystore ${keystoreunittest_bin_SRCS} )

target_link_qca_test_libraries(keystore)

add_qca_test(keystore "KeyStore")

=== unittest/macunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(macunittest_bin_SRCS macunittest.cpp)  

add_executable( macunittest ${macunittest_bin_SRCS} )

target_link_qca_test_libraries(macunittest)

add_qca_test(macunittest "MessageAuthenticationCode")

=== unittest/staticunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(staticunittest_bin_SRCS staticunittest.cpp)  

add_executable( staticunittest ${staticunittest_bin_SRCS} )

target_link_qca_test_libraries(staticunittest)

add_qca_test(staticunittest "StaticFunctions")

=== debian/changelog ===
qca2 (2.3.5-2) unstable; urgency=medium

  * Backport upstream commit 714073747c4a3ccff7a8c85c72872bdf6bd3db4a to disable
    one test that fails with OpenSSL 3.0.8; patch
    upstream_Remove-test-that-openssl-has-decided-it-s-wrong.patch.
    (Closes: #1031438)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.2, no changes needed.

 -- Pino Toscano <pino@debian.org>  Sat, 25 Feb 2023 17:05:23 +0100

qca2 (2.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.6.1, no changes needed.
  * CI: enable again the blhc job.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16
  * Update the patches:
    - define_qca_export.diff: drop, fixed upstream
    - pipeunittest_more_wait.diff: refresh
  * Factorize the common cmake arguments for different Qt versions in a single
    variable.
  * Explicitly disable all the plugins which we currently do not want to build;
    this way, having the dependencies for them installed will not cause a build
    failure due to unhandled files (Closes: #1019464)
    - pass to cmake: -DWITH_botan_PLUGIN=NO -DWITH_gcrypt_PLUGIN=NO
      -DWITH_nss_PLUGIN=NO -DWITH_pkcs11_PLUGIN=NO
  * Backport upstream commit 33a35a699928318032f62eab0e39e263c604ad9e to fix
    a crash in hashunittest; patch
    upstream_hashunittest-run-sha384longtest-only-for-providers-t.patch.
  * Update lintian overrides.
  * Export QT_PLUGIN_PATH with the build location of the plugin when running
    dh_auto_test: this way, the unit tests can use the plugins.
  * Add the gnupg test-only build dependency, needed for the tests of the gnupg
    plugin.
  * Disable pgpunittest for now, as some tests fail in build-like environments;
    patch disable_pgpunittest.diff.
  * Remove inactive Uploaders, adding myself as one to avoid leaving the source
    with no human maintainers.

 -- Pino Toscano <pino@debian.org>  Sat, 22 Oct 2022 16:37:05 +0200

=== debian/control ===
Source: qca2
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: ca-certificates,
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               gnupg <!nocheck>,
               libsasl2-dev,
               libssl-dev (>= 1.1.1~),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.14.0~),
Build-Depends-Indep: doxygen,
                     graphviz,
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://userbase.kde.org/QCA
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qca2

Package: libqca-qt5-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt5-2-plugins
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: libqca-qt5-2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: qca-qt5-2-utils
Section: utils
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca-qt5-2-dev
Section: libdevel
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt5-doc
Suggests: libqca-qt5-2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden

# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

COMMON_CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DWITH_botan_PLUGIN=NO -DWITH_gcrypt_PLUGIN=NO -DWITH_nss_PLUGIN=NO -DWITH_pkcs11_PLUGIN=NO

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	QT_SELECT=qt5 dh_auto_configure --builddirectory=build -- \
	    $(COMMON_CMAKE_ARGS) \
	    -DQT5_BUILD=ON \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/mkspecs/features"

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=build

override_dh_auto_build-indep:
	dh_auto_build --builddirectory=build -- doc
	find build/apidocs/html -name '*.md5' -delete

override_dh_auto_install-indep:

override_dh_auto_test-arch:
	QT_PLUGIN_PATH=$(CURDIR)/build/lib/qca-qt5/ dh_auto_test -a

override_dh_auto_test-indep:

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a

=== debian/tests/control ===
Tests: acc
Depends: @, dh-acc, exuberant-ctags
Restrictions: allow-stderr

Tests: ciphertest-qt5
Depends: build-essential, cmake, libqca-qt5-2-dev, libqca-qt5-2-plugins

## qca2 2.3.7

=== debian/changelog ===
qca2 (2.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Fix typo in plugins recommend in libqca-qt6-2.
  * Fix qt6 path in QCA_FEATURE_INSTALL_DIR for the Qt 6 build (although it is
    not actually used).
  * Update symbols files from the logs of buildds.
  * Add openssl as build dependency for the tests, so we get the default openssl
    configuration.

 -- Pino Toscano <pino@debian.org>  Thu, 27 Jul 2023 06:38:14 +0200

qca2 (2.3.6-4) unstable; urgency=medium

  * Upload to unstable.
  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Sat, 15 Jul 2023 22:54:34 +0200

qca2 (2.3.6-3) experimental; urgency=medium

  * General changes to the ciphertest autopkgtest source:
    - generalize it a bit w.r.t. the Qt version to use
    - drop leftovers of Qt 4 support
  * Build Qt 6 library, plugins, and tools:
    - add the qt6-base-dev, and qt6-5compat-dev build dependencies
    - add new configure, build, and test steps for a separate Qt 6 variant
    - add new libqca-qt6-2, libqca-qt6-plugins, qca-qt6-utils, and
      libqca-qt6-dev binary packages
    - extend to also support Qt 6, and add a ciphertest-qt6 autopkgtest
  * Tweak the descriptions of all the Qt 5 & Qt 6 packages to mention the Qt
    version.
  * Drop old qca-dev conflict in libqca-qt5-2-dev.

 -- Pino Toscano <pino@debian.org>  Sat, 15 Jul 2023 10:05:57 +0200

qca2 (2.3.6-2) unstable; urgency=medium

  * ciphertest-qt5 autopkgtest: call bump the cmake_minimum_required() to 3.13.
    (Closes: #1040732)

 -- Pino Toscano <pino@debian.org>  Thu, 13 Jul 2023 09:03:09 +0200

qca2 (2.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_hashunittest-run-sha384longtest-only-for-providers-t.patch: drop,
      backported from upstream
    - upstream_Remove-test-that-openssl-has-decided-it-s-wrong.patch: drop,
      backported from upstream
  * ciphertest-qt5 autopkgtest: call cmake_minimum_required() before project()
    in the CMakeLists.txt. (Closes: #1036845)

 -- Pino Toscano <pino@debian.org>  Mon, 12 Jun 2023 00:01:15 +0200

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,12 @@
                gnupg <!nocheck>,
                libsasl2-dev,
                libssl-dev (>= 1.1.1~),
+               openssl <!nocheck>,
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
                qtbase5-dev (>= 5.14.0~),
+               qt6-base-dev,
+               qt6-5compat-dev,
 Build-Depends-Indep: doxygen,
                      graphviz,
 Build-Conflicts: libqca2-dev, qca-dev
@@ -27,44 +30,95 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: ca-certificates, libqca-qt5-2-plugins
-Description: libraries for the Qt Cryptographic Architecture
+Description: libraries for the Qt Cryptographic Architecture [Qt 5]
  The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
  platform API for a range of cryptographic features, including SSL/TLS,
  X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
+ .
+ This package contains the Qt 5 version.
 
 Package: libqca-qt5-2-plugins
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: QCA plugins for libqca2
+Description: QCA plugins for libqca2 [Qt 5]
  This plugin provides cryptographic as well as helper plugins for Qt
  Cryptographic Architecture (QCA).
+ .
+ This package contains the Qt 5 versions.
 
 Package: qca-qt5-2-utils
 Section: utils
 Architecture: any
 Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Description: command line tool for the Qt Cryptographic Architecture
+Description: command line tool for the Qt Cryptographic Architecture [Qt 5]
  The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
  platform API for a range of cryptographic features, including SSL/TLS,
  X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
  .
- This package contains the command line tool for the Qt Cryptographic
- Architecture.
+ This package contains the Qt 5 version of the command line tool for the
+ Qt Cryptographic Architecture.
 
 Package: libqca-qt5-2-dev
 Section: libdevel
 Architecture: any
 Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
 Suggests: libqca2-doc (= ${source:Version})
-Conflicts: qca-dev
-Description: development files for the Qt Cryptographic Architecture
+Description: development files for the Qt Cryptographic Architecture [Qt 5]
  The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
  platform API for a range of cryptographic features, including SSL/TLS,
  X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
  .
  This package contains development files for building software that uses the
+ Qt Cryptographic Architecture using Qt 5.
+
+Package: libqca-qt6-2
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Recommends: ca-certificates, libqca-qt6-plugins
+Description: libraries for the Qt Cryptographic Architecture [Qt 6]
+ The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
+ platform API for a range of cryptographic features, including SSL/TLS,
+ X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
+ .
+ This package contains the Qt 6 version.
+
+Package: libqca-qt6-plugins
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: QCA plugins for libqca2 [Qt 6]
+ This plugin provides cryptographic as well as helper plugins for Qt
+ Cryptographic Architecture (QCA).
+ .
+ This package contains the Qt 6 versions.
+
+Package: qca-qt6-utils
+Section: utils
+Architecture: any
+Depends: libqca-qt6-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Description: command line tool for the Qt Cryptographic Architecture [Qt 6]
+ The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
+ platform API for a range of cryptographic features, including SSL/TLS,
+ X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
+ .
+ This package contains the Qt 6 version of the command line tool for the
  Qt Cryptographic Architecture.
+
+Package: libqca-qt6-dev
+Section: libdevel
+Architecture: any
+Depends: libqca-qt6-2 (= ${binary:Version}), qt6-base-dev, ${misc:Depends}
+Suggests: libqca2-doc (= ${source:Version})
+Description: development files for the Qt Cryptographic Architecture [Qt 6]
+ The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
+ platform API for a range of cryptographic features, including SSL/TLS,
+ X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
+ .
+ This package contains development files for building software that uses the
+ Qt Cryptographic Architecture using Qt 6.
 
 Package: libqca2-doc
 Section: doc

## qca2 2.3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(QCA_LIB_MAJOR_VERSION "2")
 set(QCA_LIB_MINOR_VERSION "3")
-set(QCA_LIB_PATCH_VERSION "5")
+set(QCA_LIB_PATCH_VERSION "8")
 
 if(POLICY CMP0042)
   cmake_policy(SET CMP0042 OLD)
@@ -63,7 +63,6 @@
 
 include(QcaMacro)
 include(GNUInstallDirs)
-setup_qt_dirs()
 if(BUILD_WITH_QT6)
   set(QCA_QT_PC_VERSION "Qt6Core")
   set(QCA_SUFFIX "qt6")
@@ -174,6 +173,7 @@
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
 
 if( QCA_INSTALL_IN_QT_PREFIX )
+  setup_qt_dirs()
   set(QCA_PREFIX_INSTALL_DIR "${QT_PREFIX_DIR}" CACHE PATH "Directory where qca will install")
   set(QCA_PLUGINS_INSTALL_DIR "${QT_PLUGINS_DIR}" CACHE PATH "Directory where qca plugins will install")
   set(QCA_BINARY_INSTALL_DIR "${QT_BINARY_DIR}" CACHE PATH "Directory where qca plugins will install")

=== examples/providertest/CMakeLists.txt ===
set(providertest_bin_SRCS providertest.cpp)  

add_executable(providertest ${providertest_bin_SRCS})

target_link_qca_libraries(providertest)

=== examples/tlssocket/CMakeLists.txt ===
add_executable(tlssocket tlssocket.cpp main.cpp)

target_link_qca_libraries(tlssocket)
target_link_libraries(tlssocket Qt${QT_MAJOR_VERSION}::Network)

=== plugins/qca-botan/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,17 @@
 find_package(PkgConfig REQUIRED)
-if(WITH_botan_PLUGIN STREQUAL "yes")
-  pkg_check_modules(BOTAN REQUIRED IMPORTED_TARGET botan-2)
-else()
-  pkg_check_modules(BOTAN IMPORTED_TARGET botan-2)
+
+pkg_check_modules(BOTAN IMPORTED_TARGET botan-2)
+if(NOT BOTAN_FOUND)
+  pkg_check_modules(BOTAN IMPORTED_TARGET botan-3)
+  if(BOTAN_FOUND)
+    set(CMAKE_CXX_STANDARD 20)
+    set(CMAKE_CXX_STANDARD_REQUIRED ON)
+    set(CMAKE_CXX_EXTENSIONS OFF)
+  endif()
+endif()
+
+if(WITH_botan_PLUGIN STREQUAL "yes" AND NOT BOTAN_FOUND)
+  message(FATAL_ERROR "botan requested and not found")
 endif()
 
 if(BOTAN_FOUND)

=== plugins/qca-gcrypt/CMakeLists.txt ===
if(WITH_gcrypt_PLUGIN STREQUAL "yes")
  find_package(LibGcrypt REQUIRED)
else()
  find_package(LibGcrypt)
endif()

if(LIBGCRYPT_FOUND)
  include(CheckTypeSize)

  set(remember_includes ${CMAKE_EXTRA_INCLUDE_FILES})
  set(remember_defines ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_EXTRA_INCLUDE_FILES gcrypt.h)
  set(CMAKE_REQUIRED_FLAGS ${LIBGCRYPT_CFLAGS})
  check_type_size(gcry_error_t GCRY_ERROR_T)
  set(CMAKE_REQUIRED_FLAGS ${remember_defines})
  set(CMAKE_EXTRA_INCLUDE_FILES ${remember_includes})
  if(HAVE_GCRY_ERROR_T)
    enable_plugin("gcrypt")

    set(QCA_GCRYPT_SOURCES qca-gcrypt.cpp)
    add_definitions(${LIBGCRYPT_CFLAGS})
    add_library(qca-gcrypt ${PLUGIN_TYPE} ${QCA_GCRYPT_SOURCES})

    if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
      set_property(TARGET qca-gcrypt PROPERTY SUFFIX ".dylib")
    endif()

    target_link_libraries(qca-gcrypt Qt${QT_MAJOR_VERSION}::Core ${QCA_LIB_NAME} ${LIBGCRYPT_LIBRARIES})

    if(NOT DEVELOPER_MODE)
      install(TARGETS qca-gcrypt
              LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

      install_pdb(qca-gcrypt ${QCA_CRYPTO_INSTALL_DIR})
    endif()
  else()
    message(STATUS "libgcrypt seems to be too old")
    disable_plugin("gcrypt")
  endif()
else()
  disable_plugin("gcrypt")
endif()

=== plugins/qca-ossl/CMakeLists.txt ===
# QCA OSSL

if(WITH_ossl_PLUGIN STREQUAL "yes")
  find_package(OpenSSL 1.1.1 REQUIRED)
else()
  find_package(OpenSSL 1.1.1)
endif()

if(OPENSSL_FOUND)
  enable_plugin("ossl")

  include(CheckFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
  check_function_exists(EVP_md2 HAVE_OPENSSL_MD2)
  if(HAVE_OPENSSL_MD2)
    add_definitions(-DHAVE_OPENSSL_MD2)
  else()
    message(WARNING "qca-ossl will be compiled without MD2 digest algorithm support")
  endif()

  check_function_exists(EVP_aes_128_ctr HAVE_OPENSSL_AES_CTR)
  if(HAVE_OPENSSL_AES_CTR)
    add_definitions(-DHAVE_OPENSSL_AES_CTR)
  else()
    message(WARNING "qca-ossl will be compiled without AES CTR mode encryption support")
  endif()

  check_function_exists(EVP_aes_128_gcm HAVE_OPENSSL_AES_GCM)
  if(HAVE_OPENSSL_AES_GCM)
    add_definitions(-DHAVE_OPENSSL_AES_GCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES GCM mode encryption support")
  endif()

  check_function_exists(EVP_aes_128_ccm HAVE_OPENSSL_AES_CCM)
  if(HAVE_OPENSSL_AES_CCM)
    add_definitions(-DHAVE_OPENSSL_AES_CCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES CCM mode encryption support")
  endif()

  check_function_exists(EVP_sha HAVE_OPENSSL_SHA0)
  if(HAVE_OPENSSL_SHA0)
    add_definitions(-DHAVE_OPENSSL_SHA0)
  else()
    message(WARNING "qca-ossl will be compiled without SHA-0 digest algorithm support")
  endif()

  set(QCA_OSSL_SOURCES
      qca-ossl.cpp)

  add_library(qca-ossl ${PLUGIN_TYPE} ${QCA_OSSL_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-ossl PROPERTY SUFFIX ".dylib")
  endif()


  target_link_libraries(qca-ossl Qt${QT_MAJOR_VERSION}::Core)
  target_link_libraries(qca-ossl ${QCA_LIB_NAME})
  target_link_libraries(qca-ossl OpenSSL::SSL OpenSSL::Crypto)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-ossl
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-ossl ${QCA_CRYPTO_INSTALL_DIR})
  endif()

else()
  disable_plugin("ossl")
endif()

=== unittest/bigintunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(bigintunittest_bin_SRCS bigintunittest.cpp)  

add_executable(bigintunittest ${bigintunittest_bin_SRCS} )

target_link_qca_test_libraries(bigintunittest)

add_qca_test(bigintunittest "BigInteger")

=== unittest/cms/CMakeLists.txt ===
ENABLE_TESTING()

set(cms_bin_SRCS cms.cpp)

add_executable(cms ${cms_bin_SRCS} )

target_link_qca_test_libraries(cms)
#Remove once we stop supporting openssl < 1.1.1i
target_link_libraries(cms OpenSSL::SSL OpenSSL::Crypto)

FOREACH( testFileName QcaTestRootCert.pem QcaTestClientCert.pem  QcaTestClientKey.pem )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${testFileName} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

add_qca_test(cms "CryptographicMessageSyntax")

=== unittest/dsaunittest/CMakeLists.txt ===
ENABLE_TESTING()

set( dsaunittest_bin_SRCS dsaunittest.cpp)  

add_executable( dsaunittest ${dsaunittest_bin_SRCS} )

target_link_qca_test_libraries(dsaunittest)

add_qca_test(dsaunittest "DigitalSignatureAlgorithm")

=== unittest/hashunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(hashunittest_bin_SRCS hashunittest.cpp)  

add_executable( hashunittest ${hashunittest_bin_SRCS} )

target_compile_definitions(hashunittest PRIVATE TEST_DATA_DIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
target_link_qca_test_libraries(hashunittest)


CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/data/empty ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/data/empty COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/data/twobytes ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/data/twobytes COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/data/twohundredbytes ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/data/twohundredbytes COPYONLY)

add_qca_test(hashunittest "Hashing")

=== unittest/keybundle/CMakeLists.txt ===
ENABLE_TESTING()

set(keybundleunittest_bin_SRCS keybundle.cpp)  

add_executable( keybundle ${keybundleunittest_bin_SRCS} )

target_link_qca_test_libraries(keybundle)

FOREACH( testFileName RootCA2cert.pem  servergood2.p12  
	 user2goodcert.pem  user2goodkey.pem  user2good.p12 )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${testFileName} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

add_qca_test(keybundle "KeyBundle")

=== debian/changelog ===
qca2 (2.3.8-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:51:33 +0000

qca2 (2.3.8-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:36:35 +0000

qca2 (2.3.8-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:08:05 +0000

qca2 (2.3.8-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Tue, 09 Jan 2024 22:41:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qca2
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: ca-certificates,
                cmake (>= 3.16~),

=== debian/tests/control ===
--- 
+++ 
@@ -4,3 +4,6 @@
 
 Tests: ciphertest-qt5
 Depends: build-essential, cmake, libqca-qt5-2-dev, libqca-qt5-2-plugins
+
+Tests: ciphertest-qt6
+Depends: build-essential, cmake, libqca-qt6-dev, libqca-qt6-plugins

## qca2 2.3.9

=== plugins/qca-gcrypt/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,9 @@
+find_package(PkgConfig REQUIRED)
+
 if(WITH_gcrypt_PLUGIN STREQUAL "yes")
-  find_package(LibGcrypt REQUIRED)
+  pkg_check_modules(LIBGCRYPT REQUIRED IMPORTED_TARGET libgcrypt)
 else()
-  find_package(LibGcrypt)
+  pkg_check_modules(LIBGCRYPT IMPORTED_TARGET libgcrypt)
 endif()
 
 if(LIBGCRYPT_FOUND)

=== debian/changelog ===
qca2 (2.3.9-1) unstable; urgency=medium

  * New upstream release.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Small updates to copyright.

 -- Pino Toscano <pino@debian.org>  Tue, 25 Jun 2024 05:56:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: qca2
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: ca-certificates,
                cmake (>= 3.16~),
@@ -11,7 +10,7 @@
                libsasl2-dev,
                libssl-dev (>= 1.1.1~),
                openssl <!nocheck>,
-               pkg-config,
+               pkgconf,
                pkg-kde-tools (>= 0.15.16),
                qtbase5-dev (>= 5.14.0~),
                qt6-base-dev,
@@ -19,7 +18,7 @@
 Build-Depends-Indep: doxygen,
                      graphviz,
 Build-Conflicts: libqca2-dev, qca-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://userbase.kde.org/QCA
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
